#include <iostream>
#include <libgfl.h>


void PgmRead(int & sx, int & sy, unsigned char ** buffer, const char * filename){

	FILE * fic = fopen(filename, "rb");
	fscanf(fic, "P5\n");
	fscanf(fic, "%d %d\n", &sx, &sy);
	fscanf(fic, "255\n");
	(*buffer) = new unsigned char[sx*sy];
	fread((*buffer), sizeof(unsigned char), sx*sy, fic);
	fclose(fic);

}

void PgmWrite(int sx, int sy, unsigned char * buffer, const char * filename){

	FILE * fic = fopen(filename, "wb");
	fprintf(fic, "P5\n");
	fprintf(fic, "%d %d\n", sx, sy);
	fprintf(fic, "255\n");
	fwrite(buffer, sizeof(unsigned char), sx*sy, fic);
	fclose(fic);

}

int main(int argc, char * argv[]){

	gflLibraryInit();

	unsigned char * image = 0;
	GFL_UINT8 * imagePNG = 0;
	GFL_UINT32 imagePNGSize = 0;
	unsigned char * image_decomp = 0;

	int sx, sy;
	PgmRead(sx, sy, &image, "test.pgm");

	GFL_SAVE_PARAMS save_params;
	gflGetDefaultSaveParams(&save_params);
	save_params.FormatIndex = gflGetFormatIndexByName("png");
	save_params.Compression = GFL_NO_COMPRESSION;
	save_params.CompressionLevel = 7;

	GFL_LOAD_PARAMS load_params2;
	gflGetDefaultLoadParams(&load_params2);
	load_params2.FormatIndex = gflGetFormatIndexByName("png");
	load_params2.Origin = GFL_TOP_LEFT;
	load_params2.Width = sx;
	load_params2.Height = sy;
	load_params2.Offset = 0;
	load_params2.ChannelOrder = GFL_CORDER_INTERLEAVED;
	load_params2.ChannelType = GFL_CTYPE_GREYSCALE;


	//Creating a bitmap for PNG compression into memory
	GFL_BITMAP * bitmap = 0;
	bitmap = gflAllockBitmap(GFL_GREY, sx, sy, 1, NULL);
	//bitmap->Data = new GFL_UINT8[sx*sy];
	memcpy(bitmap->Data, image, sx*sy*sizeof(unsigned char));
	gflSaveBitmapIntoMemory(&imagePNG, &imagePNGSize, bitmap, &save_params);

	FILE * fic = fopen("testPNG.png", "wb");
	fwrite(imagePNG, sizeof(unsigned char), imagePNGSize, fic);
	fclose(fic);

	//Retrieve an unsigned char * buffer from the PNG bitstream
	GFL_BITMAP * bitmap2 = 0;
	//bitmap2 = gflAllockBitmap(GFL_GREY, sx, sy, 1, NULL);
	gflLoadBitmapFromMemory(imagePNG, imagePNGSize, &bitmap2, &load_params2, NULL);  // ---> produces segfault

	//image_decomp = new unsigned char[sx*sy];
	//memcpy(image_decomp, bitmap2->Data, sx*sy*sizeof(unsigned char));


	gflLibraryExit();

	return 0;

}
